package tictactoecodingame;
import java.util.Random;


/**
 * Cette classe est une implémentation générique de l'algorithme Monte Carlo Tree Search (MCTS).
 */

public class MonteCarlo extends AlgoRecherche {
    Noeud racine;   // Noeud racine de l'arbre 
    Joueur[] joueur;  // Les 2 joueurs
    int joueurActuel; // celui qui doit jouer
    Plateau plateau;
    int tempsReflexion;     // en miliseconde
    AlgoSelection algoSelection;

    Random rnd = new Random();


    /**
     * Constructeur de la classe MonteCarlo.
     *
     * @param _j1 Le premier joueur.
     * @param _j2 Le deuxième joueur.
     * @param _algo L'algorithme de sélection à utiliser.
     * @param _temps Le temps de réflexion en millisecondes.
     */
    public MonteCarlo( Joueur _j1 , Joueur _j2 , AlgoSelection _algo , int _temps ) {
        joueur = new Joueur[2];
        joueur[0] = _j1; 
        joueur[1] = _j2;
        algoSelection = _algo;
        rnd = new Random();
        tempsReflexion = _temps;
    }

    /**
     * Cette méthode sélectionne un nœud de l'arbre pour une exploration plus approfondie.
     *
     * @param _noeud Le nœud à partir duquel la sélection commence.
     * @return Le nœud sélectionné pour lequel aucune simulation n'a encore été réalisée.
     */
    public Noeud selection(Noeud _noeud) {
        // TODO : A coder
    }

    /**
     * Cette méthode génère tous les nœuds enfants possibles (c'est-à-dire tous les coups possibles) pour le nœud donné.
     *
     * @param _noeud Le nœud à partir duquel l'expansion commence.
     */
    public void expansion(Noeud _noeud) {        
        // TODO : A coder
                    
    }

    /**
     * Cette méthode simule une partie à partir du nœud donné jusqu'à ce qu'une condition de fin de partie soit atteinte (par exemple, un joueur a gagné ou la partie est nulle).
     * La simulation est effectuée en choisissant des coups au hasard pour chaque joueur jusqu'à la fin de la partie.
     *
     * @param _noeud Le nœud à partir duquel la simulation commence.
     * @return L'identifiant du joueur qui a gagné la simulation. Si la partie est nulle, retourne -1.
     */
    public int simulation(Noeud _noeud) {           
        // TODO : A coder
    }

    /**
     * Après une simulation, cette méthode met à jour les statistiques de tous les nœuds de l'arbre de recherche depuis le nœud de la simulation jusqu'à la racine.
     * Les statistiques mises à jour comprennent le nombre de fois qu'un nœud a été joué et le nombre de victoires obtenues à partir de ce nœud.
     *
     * @param _noeud Le nœud à partir duquel la rétropropagation commence.
     * @param _vainqueur L'identifiant du joueur qui a gagné la simulation. Si la partie est nulle, c'est -1.
     */
    public void backPropagation(Noeud _noeud , int _vainqueur ) {
        // TODO : A coder
    }



    @Override
    /**
     * Cette méthode est utilisée pour déterminer le meilleur coup à jouer en fonction des résultats des simulations effectuées par l'algorithme de recherche Monte Carlo Tree Search (MCTS).
     *
     * Elle parcourt tous les fils du nœud racine (chaque fils représente un coup possible) et calcule un score pour chaque fils.
     * Ce score est le ratio entre le nombre de victoires et le nombre total de jeux pour ce fils.
     *
     * Le coup qui a le plus grand score est considéré comme le meilleur coup.
     *
     * @return Le meilleur coup à jouer.
     */
    public Coup meilleurCoup(Plateau _plateau , Joueur _joueur  ) {
        // TODO : A coder
    }



    public void joueCoup( Coup _coup ) {
        plateau.joueCoup( _coup );
        joueurActuel = (joueurActuel + 1 )%2;
    }

}
